//Adress Bytes:
/* Symbolic Constantes */

#define ADRS_H_STRNG1    0x00
#define ADRS_L_STRNG1    0x00

#define ADRS_H_STRNG2    0x00
#define ADRS_L_STRNG2    0x40

#define ADRS_H_STRNG3    0x00
#define ADRS_L_STRNG3    0x80

#define ADRS_H_STRNG4    0x00
#define ADRS_L_STRNG4    0xC0


//Die Zeichen:

#define TXT_D_OPERATING_RUN_OPEN_CHAR1  'F'
#define TXT_D_OPERATING_RUN_OPEN_CHAR2  'a'
#define TXT_D_OPERATING_RUN_OPEN_CHAR3  'e'
#define TXT_D_OPERATING_RUN_OPEN_CHAR4  'h'
#define TXT_D_OPERATING_RUN_OPEN_CHAR5  'r'
#define TXT_D_OPERATING_RUN_OPEN_CHAR6  't'
#define TXT_D_OPERATING_RUN_OPEN_CHAR7  ' '
#define TXT_D_OPERATING_RUN_OPEN_CHAR8  'A'
#define TXT_D_OPERATING_RUN_OPEN_CHAR9  'u'
#define TXT_D_OPERATING_RUN_OPEN_CHAR10  'f'

#define TXT_D_OPERATING_RUN_CLOSE_CHAR1  'F'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR2  'a'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR3  'e'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR4  'h'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR5  'r'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR6  't'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR7  ' '
#define TXT_D_OPERATING_RUN_CLOSE_CHAR8  'Z'
#define TXT_D_OPERATING_RUN_CLOSE_CHAR9  'u'


//Die Strukturen:

typedef struct  {
                  uint8_t adrs_h;
                  uint8_t adrs_l;
                  uint8_t data[64];
                }  
            tEPRM_Wrt;
typedef struct  {
                  uint8_t run_open_Char1;
                  uint8_t run_open_Char2;
                  uint8_t run_open_Char3;
                  uint8_t run_open_Char4;
                  uint8_t run_open_Char5;
                  uint8_t run_open_Char6;
                  uint8_t run_open_Char7;
                  uint8_t run_open_Char8;
                  uint8_t run_open_Char9;
                  uint8_t run_open_Char10;
                }
              tTxt_operating_run_open_D;

typedef struct  {
                  uint8_t run_close_Char1;
                  uint8_t run_close_Char2;
                  uint8_t run_close_Char3;
                  uint8_t run_close_Char4;
                  uint8_t run_close_Char5;
                  uint8_t run_close_Char6;
                  uint8_t run_close_Char7;
                  uint8_t run_close_Char8;
                  uint8_t run_close_Char9;
                }
              tTxt_operating_run_close_D;

typedef struct  {
                  tTxt_operating_run_open_D   run_open;
                  tTxt_operating_run_close_D   run_close;
                }
              tTxt_operating_D;


//Die Init der Struktur mit den Zeichen:

void Text_Init(void)
{
  Txt_D.run_open.run_open_Char1   = TXT_D_OPERATING_RUN_OPEN_CHAR1;
  Txt_D.run_open.run_open_Char2   = TXT_D_OPERATING_RUN_OPEN_CHAR2;
  Txt_D.run_open.run_open_Char3   = TXT_D_OPERATING_RUN_OPEN_CHAR3;
  Txt_D.run_open.run_open_Char4   = TXT_D_OPERATING_RUN_OPEN_CHAR4;
  Txt_D.run_open.run_open_Char5   = TXT_D_OPERATING_RUN_OPEN_CHAR5;
  Txt_D.run_open.run_open_Char6   = TXT_D_OPERATING_RUN_OPEN_CHAR6;
  Txt_D.run_open.run_open_Char7   = TXT_D_OPERATING_RUN_OPEN_CHAR7;
  Txt_D.run_open.run_open_Char8   = TXT_D_OPERATING_RUN_OPEN_CHAR8;
  Txt_D.run_open.run_open_Char9   = TXT_D_OPERATING_RUN_OPEN_CHAR9;
  Txt_D.run_open.run_open_Char10   = TXT_D_OPERATING_RUN_OPEN_CHAR10;
  
  Txt_D.run_close.run_close_Char1 = TXT_D_OPERATING_RUN_CLOSE_CHAR1;
  Txt_D.run_close.run_close_Char2 = TXT_D_OPERATING_RUN_CLOSE_CHAR2;
  Txt_D.run_close.run_close_Char3 = TXT_D_OPERATING_RUN_CLOSE_CHAR3;
  Txt_D.run_close.run_close_Char4 = TXT_D_OPERATING_RUN_CLOSE_CHAR4;
  Txt_D.run_close.run_close_Char5 = TXT_D_OPERATING_RUN_CLOSE_CHAR5;
  Txt_D.run_close.run_close_Char6 = TXT_D_OPERATING_RUN_CLOSE_CHAR6;
  Txt_D.run_close.run_close_Char7 = TXT_D_OPERATING_RUN_CLOSE_CHAR7;
  Txt_D.run_close.run_close_Char8 = TXT_D_OPERATING_RUN_CLOSE_CHAR8;
  Txt_D.run_close.run_close_Char9 = TXT_D_OPERATING_RUN_CLOSE_CHAR9;
}




//Das Beschreiben des EEPROM:

#define EEPROM_PAGE_WRITE			0x42


void EPRM_wr_Data(void)
{
  EEPROM_Write(ADRS_H_STRNG1, ADRS_L_STRNG1);
}




bool EEPROM_Write(uint8_t Adrs_high, uint8_t Adrs_low)
{
  uint8_t data[EEPROM_PAGE_WRITE];
  int32_t n;

  int x = 0;

  data[0] = Adrs_high;
  data[1] = Adrs_low;
  
  for(x = 2; x <= (EEPROM_PAGE_WRITE); x++)
  {
    data[x] = EPRM_wrt.data[x-2];
  }
         
  n = ptrI2C->SendData(EEPROM_I2C_ADDR, data, EEPROM_PAGE_WRITE, false);
  if (n != 2) return false;

  return true;
}




// Lesen des EEPROM:


void EPRM_rd_Data(void)
{
  int x = 0;
	uint8_t Data[64];
	EEPROM_Read(ADRS_H_STRNG1, ADRS_L_STRNG1, Data); //*** Kann die Variable nicht als Pointer bergeben ***
	
	for(x = 0; x <= 64; x++)
	{
    EPRM_rd.data[x] = Data[x];
	}
}





bool EEPROM_Read(uint8_t Adrs_high, uint8_t Adrs_low, uint8_t val[])
{
  uint8_t data[EEPROM_PAGE_WRITE];
  uint8_t data1[2];
	int32_t n;

	data1[0] = Adrs_high;
	data1[1] = Adrs_low;

	n = ptrI2C->SendData(IO_EXPAND_I2C_ADDR, data1, 2, true);
  if (n != 1) return false;

  n = ptrI2C->ReceiveData(IO_EXPAND_I2C_ADDR, val, EEPROM_PAGE_WRITE, false);
  if (n != 1) return false;

  return true;
}